'
'
'Clown Party program
'
'This program calculates the cost of a children's or corporate party.
'
'Last modified 16/5/7 by Bruce Riley
'

Public Class frmClown
    '
    'Declare and initialise variables used in program
    '
    Dim Number As Integer               'number of people attending party
    Dim constGST As Decimal = 0.1       'sets GST to 10%
    Dim constDiscount As Decimal = 0.9  'adjusts cost for 10% discount
    Dim subtotal As Decimal = 0         'initialises subtotal to zero

    'Variables and constants are defined below:
    'constFace is the item cost of face painting
    'constGames is the item cost of games
    'constClownCost is the item cost of 1, 2, or 3 clowns
    'constBalloons is the item cost of animal balloons
    '
    'BalloonsCost is the variable that holds total cost of the balloons
    'FaceCost is the variable that holds total cost of the face painting
    'GamesCost is the variable that holds total cost of the games
    'GSTCost is the variable that holds the GST calculation
    'Deposit is the variable that holds the amount of deposit paid
    'Balance holds quote that can be format to 2 decimal places
    'Quote is the variable that holds the outstanding amount to be paid
    '

    Dim constFace, constGames, constClownCost, constBalloons, BalloonsCost, FaceCost, GamesCost, GSTCost, Deposit, Balance, Quote As Decimal


    '
    '
    Private Sub QuoteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QuoteToolStripMenuItem.Click

        '
        'handles Quote click on the menu bar
        '

        Quote = 0               'Quote, Subtotal, FaceCost, BalloonCost
        subtotal = 0            'GamesCost, GSTCost
        FaceCost = 0            'are reset before new quote is calculated
        BalloonsCost = 0
        GamesCost = 0
        GSTCost = 0

        '
        'Sets the clown cost depending if corporate is selected or not
        '

        If cboCorporate.Text = "Y" Then     'sets clown cost at corporate rate
            If cboClowns.Text = 3 Then
                constClownCost = 120
            ElseIf cboClowns.Text = 2 Then
                constClownCost = 90
            ElseIf cboClowns.Text = 1 Then
                constClownCost = 50
            Else
                constClownCost = 0
            End If
        Else                                'sets clown cost at children's rate
            If cboClowns.Text = 3 Then
                constClownCost = 90
            ElseIf cboClowns.Text = 2 Then
                constClownCost = 70
            ElseIf cboClowns.Text = 1 Then
                constClownCost = 40
            Else
                constClownCost = 0
            End If
        End If

        '
        'Sets the cost of the face painting
        'Corporate cost uses the backslash (\) to determine how many times
        'the divisor (20) will divide evenly since the cost is based on
        'multiples of 20 adults
        '

        If chkFace.Checked = True Then
            If cboCorporate.Text = "Y" Then
                constFace = 50 * 10 / 11         ' cost for 20 people ex gst
                FaceCost = constFace * (((Val(txtNumber.Text) - 1) \ 20) + 1)
            Else                        'cost for children
                constFace = 2.2 * 10 / 11        'cost per child
                FaceCost = constFace * Val(txtNumber.Text)
            End If
        End If

        '
        'Balloon costing for corporate is calculatd the same way as
        'for face painting above.
        '

        If chkBalloons.Checked = True Then
            If cboCorporate.Text = "Y" Then
                constBalloons = 30 * 10 / 11      ' cost for 20 people ex gst
                BalloonsCost = constBalloons * (((Val(txtNumber.Text) - 1) \ 20) + 1)
            Else
                constBalloons = 1.65 * 10 / 11        'cost per child
                BalloonsCost = constBalloons * (Val(txtNumber.Text))
            End If
        End If

        '
        'Games are not available for adults but then calculates cost for children


        If chkGames.Checked = True Then
            If cboCorporate.Text = "Y" Then
                constGames = 0      ' cost for 20 people ex gst
            Else
                constGames = 1.1 * 10 / 11       'cost per child

            End If
            GamesCost = constGames * Val(txtNumber.Text)

        End If


        '
        'calculates to cost of the party
        '
        subtotal = subtotal + constClownCost + FaceCost + BalloonsCost + GamesCost

        '
        'calculates discount if a voucher is held.
        '

        If cboDiscount.Text = "Y" Then
            subtotal = subtotal * constDiscount
        End If

        '
        'displays quote
        '

        lblSubTotal.Text = Format(subtotal, "0.00")
        GSTCost = subtotal * constGST
        lblGST.Text = Format(GSTCost, "0.00")
        Balance = subtotal + GSTCost - Val(txtDeposit.Text)
        lblBalance.Text = Format(Balance, "0.00")

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        End
    End Sub


    Private Sub ClearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearToolStripMenuItem.Click

        '
        'Handles the Clear command on the menu bar
        '

        txtName.Text = ""
        txtAddress.Text = ""
        txtPhone.Text = ""
        cboEventAddress.Text = "As Above"
        txtBooking.Text = ""
        mtxTime.Text = ""
        cboDuration.Text = 0
        cboCorporate.Text = "N"
        cboDiscount.Text = "N"
        cboClowns.Text = 0
        txtNumber.Text = ""
        txtParticulars.Text = ""
        chkFace.Checked = False
        chkBalloons.Checked = False
        chkGames.Checked = False
        chkJuggling.Checked = False
        txtDeposit.Text = ""
        lblSubTotal.Text = ""
        lblGST.Text = ""
        lblBalance.Text = ""
        GSTCost = 0
        subtotal = 0
        chkGames.Enabled = True
        txtName.Focus()

    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click

        '
        'handles the save command on the menu bar
        '

        Dim FileNum As Integer = FreeFile()
        Dim StringText As String
        StringText = txtName.Text + "," + txtAddress.Text + "," + txtPhone.Text + "," + txtBooking.Text + "," + mtxTime.Text + "," + cboDuration.Text + "," + cboCorporate.Text + "," + cboDiscount.Text + "," + cboClowns.Text + "," + txtNumber.Text + "," + txtParticulars.Text + "," + CStr(chkFace.Checked) + "," + CStr(chkBalloons.Checked) + "," + CStr(chkGames.Checked) + "," + CStr(chkJuggling.Checked) + "," + txtDeposit.Text + "," + lblSubTotal.Text + "," + lblGST.Text + "," + lblBalance.Text

        'StringText = txtName.Text + vbCrLf + txtAddress.Text + vbCrLf + txtPhone.Text + vbCrLf + txtBooking.Text + vbCrLf + mtxTime.Text + vbCrLf + cboDuration.Text + vbCrLf + cboCorporate.Text + vbCrLf + cboDiscount.Text + vbCrLf + cboClowns.Text + vbCrLf + txtNumber.Text + vbCrLf + txtParticulars.Text + vbCrLf + CStr(chkFace.Checked) + vbCrLf + CStr(chkBalloons.Checked) + vbCrLf + CStr(chkGames.Checked) + vbCrLf + CStr(chkJuggling.Checked) + vbCrLf + txtDeposit.Text + vbCrLf + lblSubTotal.Text + vbCrLf + lblGST.Text + vbCrLf + lblBalance.Text

        If dlgSave.ShowDialog = DialogResult.OK Then
            FileOpen(FileNum, dlgSave.FileName, OpenMode.Output)
            PrintLine(FileNum, StringText)
            FileClose(FileNum)
        End If

    End Sub

    '
    'Following procedures handle validating
    '

    Private Sub txtBooking_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtBooking.Validating
        If IsDate(txtBooking.Text) = False Then
            e.Cancel = True             'prevents the user moving out of the control
            MsgBox("Please enter a date (dd/mm/yy)")
            txtBooking.Text = ""
        End If
    End Sub

    Private Sub txtNumber_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtNumber.Validating
        If IsNumeric(txtNumber.Text) = False Or Val(txtNumber.Text) < 0 Then
            e.Cancel = True
            MsgBox("Please enter a positive")
            txtNumber.Text = ""
        End If
    End Sub

    Private Sub txtDeposit_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtDeposit.Validating
        If IsNumeric(txtDeposit.Text) = False Or Val(txtDeposit.Text) < 0 Then
            e.Cancel = True
            MsgBox("Please enter a number 0 or greater")
            txtDeposit.Text = ""
        End If
    End Sub


    Private Sub mtxTime_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles mtxTime.Validating
        If IsDate(mtxTime.Text) = False Then
            e.Cancel = True
            MsgBox("Please enter a time 00:00 _m")
            mtxTime.Text = ""
        End If
    End Sub


    Private Sub txtPhone_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtPhone.Validating
        If IsNumeric(txtPhone.Text) = False Then
            e.Cancel = True
            MsgBox("Please enter a valid phone number")
            txtPhone.Text = ""
        End If
    End Sub

    Private Sub cboCorporate_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboCorporate.TextChanged
        '
        'disable games when coporate is checked
        '

        If cboCorporate.Text = "Y" Then
            chkGames.Enabled = False
        End If
    End Sub



    Private Sub txtName_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtName.Validating
        If IsNumeric(txtName.Text) = True Then
            MsgBox("You must type text")
        End If

    End Sub



End Class
